Index: tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/themes/base/swing/ItemSelectionChartPanel.java
===================================================================
--- tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/themes/base/swing/ItemSelectionChartPanel.java	(revision 136)
+++ tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/themes/base/swing/ItemSelectionChartPanel.java	(revision 137)
@@ -19,9 +19,9 @@
 import org.jfree.chart.plot.Pannable;
 import org.jfree.chart.plot.Plot;
 import org.jfree.chart.plot.XYPlot;
+import org.txm.ca.core.chartsengine.jfreechart.themes.highcharts.renderers.FCAItemSelectionRenderer;
 import org.txm.chartsengine.jfreechart.core.JFCChartsEngine;
 import org.txm.chartsengine.jfreechart.core.renderers.interfaces.IItemSelectionRenderer;
-import org.txm.chartsengine.jfreechart.core.themes.highcharts.defaulttheme.renderers.FCAItemSelectionRenderer;
 import org.txm.chartsengine.jfreechart.rcp.events.DefaultChartMouseListener;
 import org.txm.chartsengine.jfreechart.rcp.themes.highcharts.events.FCAChartMouseListener;
 import org.txm.chartsengine.jfreechart.rcp.themes.highcharts.events.JFCItemsKeyboardSelectionCallBack;
@@ -147,6 +147,8 @@
 			Plot plot = this.getChart().getPlot();
 			// XY plots
 			if(plot instanceof XYPlot)	{
+
+				// FIXME: this code must be moved to the CA plugin
 				// FCA
 				if(((XYPlot)plot).getRenderer() instanceof FCAItemSelectionRenderer)	{
 
Index: tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/JFCSWTChartsComponentsProvider.java
===================================================================
--- tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/JFCSWTChartsComponentsProvider.java	(revision 136)
+++ tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/JFCSWTChartsComponentsProvider.java	(revision 137)
@@ -88,7 +88,16 @@
 			JFreeChart chart = (JFreeChart) chartCreator.createChart(resultData, preferencesNode); 
 			ChartPanel chartPanel = ((JFCChartsEngine) chartsEngine).getTheme().createChartPanel(this, chart);
 			chartEditorInput.setChartContainer(chartPanel);
+
+			// Store the chart panel in the renderer (eg. can be needed to get the Graphics2D object to use in getItemShape() to compute the label text bounds and draw a background rectangle.)
+			if(chart.getPlot() instanceof XYPlot && chart.getXYPlot().getRenderer() instanceof IItemSelectionRenderer)	{
+				((IItemSelectionRenderer) chart.getXYPlot().getRenderer()).getItemsSelector().setChartPanel(chartPanel);
+			}
+			else if(chart.getPlot() instanceof CategoryPlot && chart.getCategoryPlot().getRenderer() instanceof IItemSelectionRenderer)	{
+				((IItemSelectionRenderer) chart.getCategoryPlot().getRenderer()).getItemsSelector().setChartPanel(chartPanel);
+			}
 			
+			
 			// update for shared preferences, show title, show legend, colors rendering mode, etc.
 			chartCreator.updateChart(chart, resultData, preferencesNode);
 
Index: tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/editors/___JFCChartEditorPart.java
===================================================================
--- tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/editors/___JFCChartEditorPart.java	(revision 136)
+++ tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/editors/___JFCChartEditorPart.java	(revision 137)
@@ -44,7 +44,7 @@
 	}
 	
 	
-	@Override
+	
 	public String getID()	{
 		return ID;
 	}
Index: tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/swt/JFCComposite.java
===================================================================
--- tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/swt/JFCComposite.java	(revision 136)
+++ tmp/org.txm.chartsengine.jfreechart.rcp/src/org/txm/chartsengine/jfreechart/rcp/swt/JFCComposite.java	(revision 137)
@@ -13,7 +13,7 @@
 import org.jfree.chart.ChartPanel;
 import org.jfree.chart.JFreeChart;
 import org.jfree.chart.plot.XYPlot;
-import org.txm.chartsengine.jfreechart.core.themes.highcharts.defaulttheme.renderers.FCAItemSelectionRenderer;
+import org.txm.ca.core.chartsengine.jfreechart.themes.highcharts.renderers.FCAItemSelectionRenderer;
 import org.txm.chartsengine.jfreechart.rcp.themes.base.swing.ItemSelectionChartPanel;
 import org.txm.chartsengine.rcp.IChartComponent;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
